Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/ExhaustiveOneMoveGenerator.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/ExhaustiveOneMoveGenerator.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/ExhaustiveOneMoveGenerator.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -29,8 +29,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Random;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("Exhaustive 1-Move MoveGenerator", "Exhaustively generates all possible 1-moves.")]
-  [StorableClass]
+  [StorableType("A200C3BE-D761-4F82-9CA9-44A7BB2AB0DD")]
   public class ExhaustiveOneMoveGenerator : GQAPNMoveGenerator, IStochasticOperator, IExhaustiveMoveGenerator {
     
@@ -40,5 +41,5 @@
 
     [StorableConstructor]
-    protected ExhaustiveOneMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveOneMoveGenerator(StorableConstructorFlag _) : base(_) { }
     protected ExhaustiveOneMoveGenerator(ExhaustiveOneMoveGenerator original, Cloner cloner) : base(original, cloner) { }
     public ExhaustiveOneMoveGenerator()
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/GQAPMoveGenerator.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/GQAPMoveGenerator.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/GQAPMoveGenerator.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -27,8 +27,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("GQAPMoveGenerator", "Base class for move generators for the Generalized Quadratic Assignment Problem.")]
-  [StorableClass]
+  [StorableType("4CB9C31B-4ACA-4ED6-8C7E-756319EFB8FF")]
   public abstract class GQAPMoveGenerator : SingleSuccessorOperator, IMoveGenerator, IGQAPMoveOperator,
     IProblemInstanceAwareGQAPOperator {
@@ -44,5 +45,5 @@
 
     [StorableConstructor]
-    protected GQAPMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected GQAPMoveGenerator(StorableConstructorFlag _) : base(_) { }
     protected GQAPMoveGenerator(GQAPMoveGenerator original, Cloner cloner) : base(original, cloner) { }
     public GQAPMoveGenerator()
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/GQAPNMoveGenerator.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/GQAPNMoveGenerator.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/GQAPNMoveGenerator.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,8 +28,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("N-Move Generator", "Base class for move operators that generate N-Move moves.")]
-  [StorableClass]
+  [StorableType("AC6F4053-7EEF-4125-A6F7-C93A3DC7001A")]
   public abstract class GQAPNMoveGenerator : GQAPMoveGenerator, IGQAPNMoveOperator {
 
@@ -46,5 +47,5 @@
 
     [StorableConstructor]
-    protected GQAPNMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected GQAPNMoveGenerator(StorableConstructorFlag _) : base(_) { }
     protected GQAPNMoveGenerator(GQAPNMoveGenerator original, Cloner cloner) : base(original, cloner) { }
     public GQAPNMoveGenerator()
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMove.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMove.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMove.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -25,8 +25,9 @@
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("N-Move", "An N-Move describes the relocation of n equipments to n different locations.")]
-  [StorableClass]
+  [StorableType("A3E69FD9-B578-486C-81CE-D1CB65A250CE")]
   public class NMove : Item {
     [Storable]
@@ -56,5 +57,5 @@
 
     [StorableConstructor]
-    protected NMove(bool deserializing) : base(deserializing) { }
+    protected NMove(StorableConstructorFlag _) : base(_) { }
     protected NMove(NMove original, Cloner cloner)
       : base(original, cloner) {
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveAbsoluteAttribute.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveAbsoluteAttribute.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveAbsoluteAttribute.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,8 +26,9 @@
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("N-Move Absolute TabuAttribute", "Attribute to determine whether a certain move is tabu.")]
-  [StorableClass]
+  [StorableType("39C4AE8F-9FEB-447A-878B-38796B7E8AAF")]
   public class NMoveAbsoluteTabuAttribute : Item {
 
@@ -38,5 +39,5 @@
 
     [StorableConstructor]
-    protected NMoveAbsoluteTabuAttribute(bool deserializing) : base(deserializing) { }
+    protected NMoveAbsoluteTabuAttribute(StorableConstructorFlag _) : base(_) { }
     protected NMoveAbsoluteTabuAttribute(NMoveAbsoluteTabuAttribute original, Cloner cloner) : base(original, cloner) { }
     public NMoveAbsoluteTabuAttribute(NMove move, IntegerVector assignment, double moveQuality)
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveMaker.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveMaker.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveMaker.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,8 +28,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("N-Move Maker", "Performs an N-Move.")]
-  [StorableClass]
+  [StorableType("9DAB4C4D-533A-4990-B591-A4C877F0CCE9")]
   public class NMoveMaker : SingleSuccessorOperator, IQualityAwareGQAPOperator, IMoveQualityAwareGQAPOperator, IGQAPNMoveOperator, IMoveMaker {
 
@@ -54,5 +55,5 @@
 
     [StorableConstructor]
-    protected NMoveMaker(bool deserializing) : base(deserializing) { }
+    protected NMoveMaker(StorableConstructorFlag _) : base(_) { }
     protected NMoveMaker(NMoveMaker original, Cloner cloner) : base(original, cloner) { }
     public NMoveMaker()
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveTabuChecker.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveTabuChecker.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveTabuChecker.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,8 +28,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Moves {
   [Item("N-Move TabuChecker", "Checks if a certain N-Move is tabu.")]
-  [StorableClass]
+  [StorableType("8E122154-5BCE-404A-8AD4-6C30912B3E89")]
   public class NMoveTabuChecker : SingleSuccessorOperator, ITabuChecker,
     IGQAPNMoveOperator, IMoveQualityAwareGQAPOperator {
@@ -68,5 +69,5 @@
 
     [StorableConstructor]
-    protected NMoveTabuChecker(bool deserializing) : base(deserializing) { }
+    protected NMoveTabuChecker(StorableConstructorFlag _) : base(_) { }
     protected NMoveTabuChecker(NMoveTabuChecker original, Cloner cloner) : base(original, cloner) { }
     public NMoveTabuChecker()
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveTabuMaker.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveTabuMaker.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/NMoveTabuMaker.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,8 +26,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Moves {
   [Item("N-Move TabuMaker", "Declares an N-Move tabu.")]
-  [StorableClass]
+  [StorableType("BE81C264-2DD8-4A2C-8796-D0D1E121FF53")]
   public class NMoveTabuMaker : TabuMaker, IGQAPNMoveOperator, IMoveQualityAwareGQAPOperator {
 
@@ -43,5 +44,5 @@
 
     [StorableConstructor]
-    protected NMoveTabuMaker(bool deserializing) : base(deserializing) { }
+    protected NMoveTabuMaker(StorableConstructorFlag _) : base(_) { }
     protected NMoveTabuMaker(NMoveTabuMaker original, Cloner cloner) : base(original, cloner) { }
     public NMoveTabuMaker()
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveMultiMoveGenerator.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveMultiMoveGenerator.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveMultiMoveGenerator.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,8 +28,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("Stochastic N-Move MultiMoveGenerator", "Randomly samples a number of N-Moves.")]
-  [StorableClass]
+  [StorableType("EEE53E16-0FB6-4041-A9AC-ECDA5E73A505")]
   public class StochasticNMoveMultiMoveGenerator : GQAPNMoveGenerator, IStochasticOperator, IMultiMoveGenerator {
     
@@ -42,5 +43,5 @@
 
     [StorableConstructor]
-    protected StochasticNMoveMultiMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected StochasticNMoveMultiMoveGenerator(StorableConstructorFlag _) : base(_) { }
     protected StochasticNMoveMultiMoveGenerator(StochasticNMoveMultiMoveGenerator original, Cloner cloner) : base(original, cloner) { }
     public StochasticNMoveMultiMoveGenerator()
Index: branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveSingleMoveGenerator.cs
===================================================================
--- branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveSingleMoveGenerator.cs	(revision 15677)
+++ branches/1614_GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Moves/StochasticNMoveSingleMoveGenerator.cs	(revision 16728)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -31,8 +31,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Random;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
   [Item("Stochastic N-Move SingleMoveGenerator", "Randomly samples a single N-Move.")]
-  [StorableClass]
+  [StorableType("7CC8D0D6-C865-485F-A16A-C2ED764C6AC4")]
   public class StochasticNMoveSingleMoveGenerator : GQAPNMoveGenerator, IStochasticOperator, ISingleMoveGenerator {
     
@@ -42,5 +43,5 @@
 
     [StorableConstructor]
-    protected StochasticNMoveSingleMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected StochasticNMoveSingleMoveGenerator(StorableConstructorFlag _) : base(_) { }
     protected StochasticNMoveSingleMoveGenerator(StochasticNMoveSingleMoveGenerator original, Cloner cloner) : base(original, cloner) { }
     public StochasticNMoveSingleMoveGenerator()